// FILE: SerialPortX.java
// 2002.5.12
// Rev : org
// 2006.9.3
// Rev : B
// package sewageControl;
// writer : ѽ¹

package moduleMonitor.module;

import java.io.*;
import java.util.*;
import gnu.io.*;
import moduleMonitor.utility.*;

//int[][][] moduleStateA = 
//{
//	{
//		{11,0},{12,0},{13,0}
//	},
//	{
//		{21,0},{22,0},{23,0}
//	}
//	{
//		{1,0},{1,0},{1,0}
//	},
//	{
//		{0,0},{0,0},{0,0}
//	},
//	{
//		{1,0},{0,0},{1,0}
//	},
//	{
//		{0,0},{1,0},{0,0}
//	}
//};
	
public class DataThread implements Runnable, SerialPortEventListener ,DataThreadFace
{
	Enumeration portList;
	CommPortIdentifier portId;
	InputStream rsInputStream;
	OutputStream rsOutputStream;
	SerialPort serialPort;
	Thread readThread;
	ModuleControlFace pseudoModule;
	int[][][] moduleStateA;

	int SLEEP_TIME = 1000;// total 10
//	char msg= 0x30;
	char msg[] = {0x10,0x20,0x30,0x40,0x50,0x60,0x70,0x80};
	byte[] rsBuffer = new byte[8];
	String packetData ;
	int sensorData[][] = new int[2][4];
	String sensorNo;
	String sensorValue;
	int value;
	int col;
	int row;
	char packet;
	int count=0;
	int loop;
	String subData;
    StringTokenizer stModule;
    StringTokenizer stData;
	
	
//	public static void main(String[] args) 
//	{
//		DataThread serialPortX = new DataThread();
//	}
	
	public DataThread(ModuleControlFace pseudoModule) 
	{
		this.pseudoModule = pseudoModule;
		moduleStateA = pseudoModule.getModuleStateA(); 
		portList = CommPortIdentifier.getPortIdentifiers();

		while (portList.hasMoreElements()) 
		{
			portId = (CommPortIdentifier) portList.nextElement();
			p.r(this,"portId.getName()", portId.getName());
			if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL) 
			{
				if (portId.getName().equals("/dev/ttyS2")) 
				{
					p.r(this,"portId ", portId);
					p.r(this,"portId.getName() ", portId.getName());
					p.r(this,"portId.getPortType() ", portId.getPortType());
					break;
				}
				else
				{
					p.r(this,"No Serial port available...");
				}
			}
		}

		try // from here can be inserted to break upper.
		{
			serialPort = (SerialPort) portId.open("FROM_RS232", 2000);
		} 
		catch (PortInUseException e) 
		{
		}
		
		try 
		{
			rsInputStream = serialPort.getInputStream();
			rsOutputStream = serialPort.getOutputStream();
		} 
		catch (IOException e) 
		{
		}
		
		try 
		{
			serialPort.addEventListener(this);
		} 
		catch (TooManyListenersException e) 
		{
		}
		
		serialPort.notifyOnDataAvailable(true);
		try 
		{
//			serialPort.setSerialPortParams(9600,
			serialPort.setSerialPortParams(2400,
			SerialPort.DATABITS_8,
			SerialPort.STOPBITS_1,
			SerialPort.PARITY_NONE);
		}
		catch (UnsupportedCommOperationException e) 
		{
		}
		
		readThread = new Thread(this);
		readThread.start();
	}

	public void run() 
	{
		while(true)
		{
			try 
			{
//				count = (count < 3 ? ++count:0);
				count = (count < 3 ? 0:0);
				writeMessage(msg[count]);
				Thread.sleep(SLEEP_TIME);
//				writeMessage(getPacket());
				Thread.sleep(SLEEP_TIME*7);
				printData();
				Thread.sleep(SLEEP_TIME);
//				msg = (msg < 0x31 ?  ++msg : 0x30);

				
			} 
			catch (InterruptedException e) 
			{}
		}
	}

	public InputStream getInputStream()
	{
		return rsInputStream;
	}
	
	public OutputStream getOutputStream()
	{
		return rsOutputStream;
	}
	
	
	public void setMessage(char msg)
	{
		this.msg[0] = msg;
	}
	
	public void writeMessage(String message)// String
	{
		try
		{
			rsOutputStream.write(message.getBytes());
		}
		catch(IOException ioE)
		{
			p.r(this,"write string",ioE.getMessage());
		}
	}

	
	public void writeMessage(char ch)// character
	{
		try
		{
			rsOutputStream.write(ch);
		}
		catch(IOException ioE)
		{
			p.r(this,"write ch",ioE.getMessage());
		}
	}
	
	public void serialEvent(SerialPortEvent event) 
	{
		switch(event.getEventType()) 
		{
			case SerialPortEvent.BI:
			case SerialPortEvent.OE:
			case SerialPortEvent.FE:
			case SerialPortEvent.PE:
			case SerialPortEvent.CD:
			case SerialPortEvent.CTS:
			case SerialPortEvent.DSR:
			case SerialPortEvent.RI:
			case SerialPortEvent.OUTPUT_BUFFER_EMPTY:
			break;
			case SerialPortEvent.DATA_AVAILABLE:// data receive
			{
					try 
					{
						while (rsInputStream.available() > 0) 
						{
						  int numBytes = rsInputStream.read(rsBuffer);
						}
						packetData = new String(rsBuffer);
						if(packetData.startsWith("[")&& packetData.endsWith("]"))
						{
							p.r(this,"good serial data ", packetData );
							p.r(this, "********  Serial Data good 1st : ",packetData.substring(0,1));
							packetData = packetData.substring(1, 7);
							dataProcess();
							break;
						}
						else
						{
							p.r(this,"bed serial data ", packetData );
							p.r(this, "********  Serial Data bed 2nd : ",packetData.substring(0,1));
							return;
						}
					} 
					catch (IOException e) 
					{
					}
					break;
			}
		}
	}

	void dataProcess()
	{
//	     System.out.println("RS activated");
	     stModule = new StringTokenizer(packetData,"$");
	     {
	    	 for ( loop = 0 ; loop < 8; loop ++)
	    	 {
				try 
				{
					subData = stModule.nextToken();
					stData = new StringTokenizer(subData,":");
					sensorNo = stData.nextToken();
					sensorValue = stData.nextToken();
				} 
				catch (Exception e) 
				{
					sensorNo= "\0";
					sensorValue = "\0";
					return ;
				}
		    	 p.r(this,"sensorNo", sensorNo);
		    	 p.r(this,"sensorValue", sensorValue);
				 col = Integer.valueOf(sensorNo).intValue()%10;
				 row = (Integer.valueOf(sensorNo).intValue()-col)/10;

				 value = Integer.valueOf(sensorValue).intValue();
				 sensorData[row][col]=value;
	    	 }
	     }
	}
	
	void printData()
	{
   	 	for (int row = 0; row < 2; row ++)
	    {
   		 	for (int col = 0; col < 4; col++)
	    	 {
	    		 System.out.println(" sensorData [" + row + "]" + "[" + col + "]  : " + sensorData[row][col]);
//	    		 System.out.println(" sensorData [" + (Integer.valueOf(sensorNo).intValue()-(Integer.valueOf(sensorNo).intValue()%100))/100 + "]" + "[" + Integer.valueOf(sensorNo).intValue()%10 + "]  : " + Integer.valueOf(sensorValue).intValue());
	    	 }
	    }
   	 	pseudoModule.setModuleState(sensorData);
	}
	
	char getPacket()
	{
		packet = 0x00;
		for (col = 0; col < 3 ; col++)
		{
			packet = (char)col;
			packet <<= 4;
			for (row = 2; row < 6 ; row++)
			{
				packet |= moduleStateA[row][col][0]<< (6-row);
			}
		}
//		return packet;
		return 0X40;
	}
}
