// File : ModuleP.java
// Gen Date : 2005.12.12
// Rev : C
// Package : module
// Writer :   

package moduleMonitor.module;

import javax.swing.Icon;
import javax.swing.JLabel;

import moduleMonitor.utility.InitProperty;

abstract class ModuleP implements ModuleFace//, ModuleObserver
{
	String moduleName = "INIT";
	int moduleNo = 0;
	int currentValue = 0;
	int state = 0;
	int evt = 0;
	String status[]={"OFF","ON"};

	int LEVEL_SENSOR;
	int RAD_THREASHOLD;
	int RAD_SENSOR;
	int LEVEL_THREASHOLD;
	int INLET_VALVE;
	int CHECK_VALVE;
	int DRAIN_VALVE;
	int OPER_SW;
	int NORMAL_STATE;
	int NORMAL_VALUE;
	int OPEN_STATE;
	int OPEN_VALUE;
	int CLOSE_STATE;
	int CLOSE_VALUE;
	int START_STATE;
	int START_VALUE;
	int STOT_STATE;
	int STOT_VALUE;
	
	int LEVEL_RESET;
	int RAD_RESET;
	int INLET_RESET;
	int CHECK_RESET;
	int DRAIN_RESET;
	int OPER_SW_RESET;
	
	int LEVEL_READ;
	int RAD_READ;
	int INLET_READ;
	int CHECK_READ;
	int DRAIN_READ;
	int OPER_SW_READ;
	
	int LEVEL_OPEN;
	int RAD_ON_STATE;
	int INLET_OPEN;
	int CHECK_OPEN;
	int DRAIN_OPEN;
	int OPER_SW_START;
	
	int LEVEL_CLOSE;
	int RAD_OFF_STATE;
	int INLET_CLOSE;
	int CHECK_CLOSE;
	int DRAIN_CLOSE;
	int OPER_SW_STOP;
	final int READ_COMMAND=1111;
	final int ON_COMMAND=2222;
	final int OFF_COMMAND=3333;

	
	
	JLabel moduleLabel = new JLabel(moduleName);
	Icon moduleIcon[] = new Icon[2];
	JLabel moduleImage = new JLabel();
	JLabel valueLabel = new JLabel(String.valueOf(currentValue));
	ModuleControlFace pseudoModule;
	
	public ModuleP(ModuleControlFace pseudoModule)
	{
		this.pseudoModule = pseudoModule;

		InitProperty initProperty = InitProperty.getInstance();
		LEVEL_SENSOR = Integer.parseInt(initProperty.getValue("LEVEL_SENSOR"));
		RAD_SENSOR = Integer.parseInt(initProperty.getValue("RAD_SENSOR"));
		INLET_VALVE = Integer.parseInt(initProperty.getValue("INLET_VALVE"));
		CHECK_VALVE = Integer.parseInt(initProperty.getValue("CHECK_VALVE"));
		DRAIN_VALVE = Integer.parseInt(initProperty.getValue("DRAIN_VALVE"));
		OPER_SW = Integer.parseInt(initProperty.getValue("OPER_SW"));
		NORMAL_STATE = Integer.parseInt(initProperty.getValue("NORMAL_STATE"));
		NORMAL_VALUE = Integer.parseInt(initProperty.getValue("NORMAL_VALUE"));

		OPEN_STATE = Integer.parseInt(initProperty.getValue("OPEN_STATE"));
		OPEN_VALUE = Integer.parseInt(initProperty.getValue("OPEN_VALUE"));
		CLOSE_STATE = Integer.parseInt(initProperty.getValue("CLOSE_STATE"));
		CLOSE_VALUE = Integer.parseInt(initProperty.getValue("CLOSE_VALUE"));
		START_STATE = Integer.parseInt(initProperty.getValue("START_STATE"));
		START_VALUE = Integer.parseInt(initProperty.getValue("START_VALUE"));
		STOT_STATE = Integer.parseInt(initProperty.getValue("STOT_STATE"));
		STOT_VALUE = Integer.parseInt(initProperty.getValue("STOT_VALUE"));
		NORMAL_VALUE = Integer.parseInt(initProperty.getValue("NORMAL_VALUE"));
		RAD_THREASHOLD = Integer.parseInt(initProperty.getValue("RAD_THREASHOLD"));
		LEVEL_THREASHOLD = Integer.parseInt(initProperty.getValue("LEVEL_THREASHOLD"));


		LEVEL_RESET = Integer.parseInt(initProperty.getValue("LEVEL_RESET"));
		RAD_RESET = Integer.parseInt(initProperty.getValue("RAD_RESET"));
		INLET_RESET = Integer.parseInt(initProperty.getValue("INLET_RESET"));
		CHECK_RESET = Integer.parseInt(initProperty.getValue("CHECK_RESET"));
		DRAIN_RESET = Integer.parseInt(initProperty.getValue("DRAIN_RESET"));
		OPER_SW_RESET = Integer.parseInt(initProperty.getValue("OPER_SW_RESET"));
		LEVEL_READ = Integer.parseInt(initProperty.getValue("LEVEL_READ"));
		RAD_READ = Integer.parseInt(initProperty.getValue("RAD_READ"));
		INLET_READ = Integer.parseInt(initProperty.getValue("INLET_READ"));
		CHECK_READ = Integer.parseInt(initProperty.getValue("CHECK_READ"));
		DRAIN_READ = Integer.parseInt(initProperty.getValue("DRAIN_READ"));
		OPER_SW_READ = Integer.parseInt(initProperty.getValue("OPER_SW_READ"));
		LEVEL_OPEN = Integer.parseInt(initProperty.getValue("LEVEL_OPEN"));
//		RAD_START = Integer.parseInt(initProperty.getValue("RAD_START"));
		RAD_ON_STATE = Integer.parseInt(initProperty.getValue("RAD_ON_STATE"));
		INLET_OPEN = Integer.parseInt(initProperty.getValue("INLET_OPEN"));
		CHECK_OPEN = Integer.parseInt(initProperty.getValue("CHECK_OPEN"));
		DRAIN_OPEN = Integer.parseInt(initProperty.getValue("DRAIN_OPEN"));
		OPER_SW_START = Integer.parseInt(initProperty.getValue("OPER_SW_START"));
		LEVEL_CLOSE = Integer.parseInt(initProperty.getValue("LEVEL_CLOSE"));
//		RAD_STOP = Integer.parseInt(initProperty.getValue("RAD_STOP"));
		RAD_OFF_STATE = Integer.parseInt(initProperty.getValue("RAD_OFF_STATE"));
		INLET_CLOSE = Integer.parseInt(initProperty.getValue("INLET_CLOSE"));
		CHECK_CLOSE = Integer.parseInt(initProperty.getValue("CHECK_CLOSE"));
		DRAIN_CLOSE = Integer.parseInt(initProperty.getValue("DRAIN_CLOSE"));
		OPER_SW_STOP = Integer.parseInt(initProperty.getValue("OPER_SW_STOP"));
	}
			
	public void reset()
	{
		state = NORMAL_STATE;
		currentValue = NORMAL_VALUE;
	}
	
	public int getModuleNo()
	{
		return moduleNo;
	}
	
	public void setModuleNo(int moduleNo)
	{
		this.moduleNo = moduleNo;
	}
	
	public String getModuleName()
	{
		return moduleName;
	}
	
	public void setModuleName(String moduleName)
	{
		this.moduleName = moduleName;
	}
	public JLabel getModuleLabel()
	{
		return moduleLabel;
	}
	
	public void setModuleLabel(String text)
	{
		moduleLabel.setText(text);
	}
	
	public JLabel getValueLabel()
	{
		return valueLabel;
	}
	
	public void setValueLabel(int val)
	{
		valueLabel.setText(String.valueOf(val));
	}

	public void setValueLabel(String str)
	{
		valueLabel.setText(str);
	}
	
	public void setValueLabel(int val, String str)
	{
		valueLabel.setText(String.valueOf(val)+ " : " + str);
	}

	public JLabel getModuleImage()
	{
		return moduleImage;
	}
	
	public Icon[] getModuleIcon()
	{
		return moduleIcon;
	}

	public void notify( int moduleNo, int protocol)
	{
		if (this.moduleNo == moduleNo)
		{
			switch(protocol)
			{
				case READ_COMMAND://0601://OPER_SW_READ: // <- sensor
					setState(getCurrentValue());
					sendDatum();
					break;
				
				case ON_COMMAND://OPER_SW_START: // <- server
					operationStart();
					break;
				
				case OFF_COMMAND://OPER_SW_STOP: // <- server
					operationStop();
					break;
			}
		}
	}

	public void sendDatum()
	{
		pseudoModule.sendDatum(getModuleNo(),getCurrentValue());
	}

	public abstract int getState();
	public abstract void setState(int state);
	public abstract int getCurrentValue();
	public abstract void setCurrentValue(int currentValue);
	public abstract void operationStart();
	public abstract void operationStop();
}

