// File : ModuleThread.java
// Gen Date : 2005.12.8
// Rev : C
// Package : module
// Writer :   

package moduleMonitor.module;

import java.io.DataInputStream;
import java.io.DataOutputStream;

import javax.swing.JLabel;

import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

class ModuleThread implements Runnable
{
	DataInputStream dis;
	DataOutputStream dos;
	String systemID;
	String message;
	String CHAR_SET;
	ModuleControlFace pseudoModule;
	ModuleListener moduleP;
	JLabel msgLabel;
	int moduleNo;
	int MODULE_PAUSE_TIME;
	int protocol;
	int SIZE;
	int MODULEIDX;
	int SYSTEMIDX;
	int CMDSRTIDX;
	byte[] data;
	boolean LOOP = true;
	int DIGIT;
	int[][][] moduleStateA;
	
	public ModuleThread(ModuleControlFace pseudoModule, String systemID, DataInputStream dis, DataOutputStream dos, ModuleListener moduleP, int MODULE_PAUSE_TIME)
	{
		this.dis = dis;
		this.dos = dos;
		this.moduleP = moduleP;
		this.pseudoModule = pseudoModule;
		this.MODULE_PAUSE_TIME = MODULE_PAUSE_TIME;
		InitProperty initProperty = InitProperty.getInstance();
		SIZE = Integer.parseInt(initProperty.getValue("SIZE"));
		CHAR_SET = initProperty.getValue("CHAR_SET");
		DIGIT = Integer.parseInt(initProperty.getValue("DIGIT"));
		p.r(this,"ModuleThread-constructor",SIZE);
		SYSTEMIDX = Integer.parseInt(initProperty.getValue("SYSTEMIDX"));
		p.r(this,"SYSTEMIDX",SYSTEMIDX);
		MODULEIDX = Integer.parseInt(initProperty.getValue("MODULEIDX"));
		p.r(this,"MODULEIDX",MODULEIDX);
		CMDSRTIDX = Integer.parseInt(initProperty.getValue("CMDSRTIDX"));
		p.r(this,"CMDSRTIDX",CMDSRTIDX);
		data = new byte[SIZE];
		moduleStateA = pseudoModule.getModuleStateA();
	}
	
	public void run()
	{
		while(LOOP)
		{
			try
			{
				dis.readFully(data);
				message = new String(data,CHAR_SET);
				p.r(this,"run()", message);
				if( ! (message == null))
				{
					String moduleID = message.substring(MODULEIDX,MODULEIDX+4);
					moduleNo = Integer.parseInt(moduleID)-DIGIT;
					p.r(this,"moduleNo in run() ",moduleNo);
					String command = message.substring(CMDSRTIDX,CMDSRTIDX+4);
					protocol = Integer.parseInt(command)-DIGIT;
					p.r(this,"protocol in run() ",protocol);
					pseudoModule.notifies(moduleNo, protocol);
				}
				else
				{
					Thread.currentThread().sleep(MODULE_PAUSE_TIME);
				}
			}
			
			catch(Exception e)
			{
				e.printStackTrace();
				p.r(this,"CLIENT LOG OUT !  BYE BYE...");
				break;
			}
		}
	}
	
//	void decodeProtocol(int moduleNo, int protocol) 
//	{
//		p.r(this,"decodeProtocol-moduleNo", moduleNo);
//		p.r(this,"decodeProtocol-protocol", protocol);
//		
//		pseudoModule.notifies( moduleNo, protocol);// <- thread
//	}

	public void sendDatum(int moduleNo, int val)
	{
		try
		{
			data = (systemID + int2String(moduleNo) + int2String(val)).getBytes(CHAR_SET);
			p.r(this,"sendDatum",String.valueOf(data));
			dos.write(data,0,SIZE);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	String int2String(int val)
	{
		return String.valueOf(val);
	}
}
