// File : PseudoModule.java
// Gen Date : 2005.12.05
// Rev : B
// Package : module
// Writer :   

package moduleMonitor.module;

import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JLabel;

import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

class PseudoModule extends JFrame implements ModuleListener, ActionListener, ModuleControlFace
{
	Vector moduleV = new Vector();
	int[][][] moduleStateA = {{{11,0},{12,0},{13,0}},{{21,0},{22,0},{23,0}},{{1,0},{1,0},{1,0}},{{0,0},{0,0},{0,0}},{{1,0},{0,0},{1,0}},{{0,0},{1,0},{0,0}}};
	LevelSensorP levelSensor[];
	RadSensorP radSensor[];
	ValveP inletValve[];
	ValveP checkValve[];
	ValveP drainValve[];
	MotorP motor[];
	RadMotorP radMotor[];
	Iterator iter;
//	MotorP checkMotor;
//	MotorP drainMotor;
	
	InitProperty initProperty;
	Container moduleScreen;

	InputStream is;
	OutputStream os;
//	ObjectOutputStream oos;
//	ObjectInputStream ois;
	DataInputStream dis;
	DataOutputStream dos;
	
	ModuleFace moduleP;
//	BufferedReader br;
	
	Socket toServer;
	Socket fmServer;
	
	String serverURL;
	String CHAR_SET;
	static int PORT;
	static int QUE_LENGTH;
	static int MODULE_PAUSE_TIME;
	String DUMMY = "__:-:";
//	char[] data;
//	byte[] data;
	String data;
	String DM = ":";
	String systemID="KOREKKDPHINUSWCL";
	String FILLER = "abcdefgh";
	String packet;	
	
	int NUM_MODULE;
	int SIZE;
	int DIGIT;
	int ROW;
	int COL;
	int STATER;
	int READ_MODULE_VALUE;
	
	int WIN_X;
	int WIN_Y;
	int LOC_X;
	int LOC_Y;
	
	int RAD_INIT;
	int LEVEL_INIT;
	int INLET_VALVE_INIT;
	int CHECK_VALVE_INIT;
	int DRAIN_VALVE_INIT;
	int MOTOR_INIT;
	int RAD_MOTOR_INIT;
	int LEVEL_MAX;
	int RAD_MAX;
	float radValue;
	float levelValue;
	
	
	
	public PseudoModule()
	{
		super("PSEUDO MODULE FOR MONITOR SIMULATION");
		initProperty = InitProperty.getInstance();
		initializeParameter();
		init();
	}
	
	void initializeParameter()
	{
		NUM_MODULE = Integer.parseInt(initProperty.getValue("NUM_MODULE"));
		PORT = Integer.parseInt(initProperty.getValue("PORT"));
		serverURL = initProperty.getValue("serverURL");
		QUE_LENGTH = Integer.parseInt(initProperty.getValue("QUE_LENGTH"));
		MODULE_PAUSE_TIME = Integer.parseInt(initProperty.getValue("MODULE_PAUSE_TIME"));
		SIZE = Integer.parseInt(initProperty.getValue("SIZE"));
		CHAR_SET = initProperty.getValue("CHAR_SET");
		DIGIT = Integer.parseInt(initProperty.getValue("DIGIT"));
		ROW = Integer.parseInt(initProperty.getValue("ROW"));
		COL = Integer.parseInt(initProperty.getValue("COL"));
		STATER = Integer.parseInt(initProperty.getValue("STATER"));
		READ_MODULE_VALUE = Integer.parseInt(initProperty.getValue("READ_MODULE_VALUE"));
		RAD_MAX = Integer.parseInt(initProperty.getValue("RAD_MAX"));
		LEVEL_MAX = Integer.parseInt(initProperty.getValue("LEVEL_MAX"));

//		data = new char[SIZE];
//		data = new byte[SIZE];
		WIN_X = Integer.parseInt(initProperty.getValue("WIN_X"));
		WIN_Y = Integer.parseInt(initProperty.getValue("WIN_Y"));
		LOC_X = Integer.parseInt(initProperty.getValue("LOC_X"));
		LOC_Y = Integer.parseInt(initProperty.getValue("LOC_Y"));
		RAD_INIT = Integer.parseInt(initProperty.getValue("RAD_INIT"));
		LEVEL_INIT = Integer.parseInt(initProperty.getValue("LEVEL_INIT"));
		INLET_VALVE_INIT= Integer.parseInt(initProperty.getValue("INLET_VALVE_INIT"));
		CHECK_VALVE_INIT= Integer.parseInt(initProperty.getValue("CHECK_VALVE_INIT"));
		DRAIN_VALVE_INIT= Integer.parseInt(initProperty.getValue("DRAIN_VALVE_INIT"));
		MOTOR_INIT= Integer.parseInt(initProperty.getValue("MOTOR_INIT"));
		RAD_MOTOR_INIT= Integer.parseInt(initProperty.getValue("RAD_MOTOR_INIT"));
	}
	
	void init()
	{
		makeInitSensor();
		makeInitValve();
		makeInitMotor();
		makeInitRadMotor();
		
		for ( int i = 0;  i < NUM_MODULE ; i++)
		{
			makeSensor(i);
			makeValve(i);
			makeMotor(i);
//			makeRadMotor(i);
		}
		makeScreen();
		setSize(WIN_X,WIN_Y);
		setLocation(LOC_X,LOC_Y+384);
		setVisible(true);
		connect();
	}
	
	void makeInitSensor()
	{
		levelSensor = new LevelSensorP[NUM_MODULE];
		radSensor = new RadSensorP[NUM_MODULE];
	}
	
	void makeInitValve()
	{
		inletValve = new ValveP[NUM_MODULE];
//		checkValve = new ValveP[NUM_MODULE];
		radMotor = new RadMotorP[NUM_MODULE];
		drainValve = new ValveP[NUM_MODULE];
	}

	void makeInitMotor()
	{
		motor = new MotorP[NUM_MODULE];// reduce
	}

	void makeInitRadMotor()
	{
		radMotor = new RadMotorP[NUM_MODULE];// reduce
	}

	void makeSensor(int n)
	{
		levelSensor[n] = new LevelSensorP(this);
		int LEVEL_SENSOR = Integer.parseInt(initProperty.getValue("LEVEL_SENSOR"));
		levelSensor[n].setModuleName("LS" + String.valueOf(LEVEL_SENSOR + n));
		levelSensor[n].setModuleLabel("LS" + String.valueOf(LEVEL_SENSOR + n));
		levelSensor[n].setValueLabel(LEVEL_INIT,"%");
		levelSensor[n].setModuleNo(LEVEL_SENSOR + n);
		levelSensor[n].setCurrentValue(LEVEL_INIT+38);
		addModule(levelSensor[n]);
		p.r(this, "LEVEL_SENSOR", LEVEL_SENSOR);
		p.r(this.toString()+"levelSensor",String.valueOf(n),levelSensor[n].getModuleName());
//		p.r(this.toString()+"levelSensor",String.valueOf(n),levelSensor[n].getModuleLabel());
		p.r(this.toString()+"levelSensor",String.valueOf(n),levelSensor[n].getModuleNo());

		radSensor[n] = new RadSensorP(this);
		int RAD_SENSOR = Integer.parseInt(initProperty.getValue("RAD_SENSOR"));
		radSensor[n].setModuleName("RS" + String.valueOf(RAD_SENSOR+n));
		radSensor[n].setModuleLabel("RS" + String.valueOf(RAD_SENSOR+n));
		radSensor[n].setValueLabel(RAD_INIT,"X");
		radSensor[n].setModuleNo(RAD_SENSOR + n);
		radSensor[n].setCurrentValue(RAD_INIT+38);
		addModule(radSensor[n]);
	}
	
	void makeValve(int n)
	{
		inletValve[n] = new ValveP(this);
		int INLET_VALVE = Integer.parseInt(initProperty.getValue("INLET_VALVE"));
		inletValve[n].setModuleName("IV" + String.valueOf(INLET_VALVE + n));
		inletValve[n].setModuleLabel("IV" + String.valueOf(INLET_VALVE + n));
		inletValve[n].setValueLabel(INLET_VALVE_INIT,"N/A");
		inletValve[n].setModuleNo(INLET_VALVE + n);
		inletValve[n].setCurrentValue(INLET_VALVE_INIT);
//		
//		Icon[] inletModuleIcon = inletValve[n].getModuleIcon();
//		inletValve[n].getModuleImage().setIcon(inletModuleIcon[0]);
		addModule(inletValve[n]);
//
//		radMotor[n] = new RadMotorP(this);
//		int RAD_MOTOR = Integer.parseInt(initProperty.getValue("RAD_MOTOR"));
//		radMotor[n].setModuleName("CV" + String.valueOf(RAD_MOTOR + n));
//		radMotor[n].setModuleLabel("CV" + String.valueOf(RAD_MOTOR + n));
//		radMotor[n].setValueLabel(RAD_MOTOR_INIT,"N/A");
//		radMotor[n].setModuleNo(RAD_MOTOR + n);
//		radMotor[n].setCurrentValue(RAD_MOTOR_INIT);
////		Icon[] checkModuleIcon = checkValve[n].getModuleIcon();
////		checkValve[n].getModuleImage().setIcon(checkModuleIcon[1]); // DEFAULT = 0
//		addModule(radMotor[n]);

		makeRadMotor(n);
		
		drainValve[n] = new ValveP(this);
		int DRAIN_VALVE = Integer.parseInt(initProperty.getValue("DRAIN_VALVE"));
		drainValve[n].setModuleName("DV" + String.valueOf(DRAIN_VALVE + n));
		drainValve[n].setModuleLabel("DV" + String.valueOf(DRAIN_VALVE + n));
		drainValve[n].setValueLabel(DRAIN_VALVE_INIT,"N/A");
		drainValve[n].setModuleNo(DRAIN_VALVE + n);
		drainValve[n].setCurrentValue(DRAIN_VALVE_INIT);
//		Icon[] drainModuleIcon = drainValve[n].getModuleIcon();
//		drainValve[n].getModuleImage().setIcon(drainModuleIcon[0]);
		addModule(drainValve[n]);
	}
	
	void makeMotor(int n)
	{
		motor[n] = new MotorP(this);
		int MOTOR =  Integer.parseInt(initProperty.getValue("MOTOR"));
		motor[n].setModuleName("MT"+String.valueOf(MOTOR + n));
		motor[n].setModuleLabel("MT"+String.valueOf(MOTOR + n));
		motor[n].setValueLabel(MOTOR_INIT,"N/A");
		motor[n].setModuleNo(MOTOR + n);
		motor[n].setCurrentValue(MOTOR_INIT);
//		Icon[] moduleIcon = motor[n].getModuleIcon();
//		motor[n].getModuleImage().setIcon(moduleIcon[0]); // DEFAULT = 0
		addModule(motor[n]);
	}

	void makeRadMotor(int n)
	{
		radMotor[n] = new RadMotorP(this);
		int RAD_MOTOR =  Integer.parseInt(initProperty.getValue("RAD_MOTOR"));
		radMotor[n].setModuleName("RM"+String.valueOf(RAD_MOTOR + n));
		radMotor[n].setModuleLabel("RM"+String.valueOf(RAD_MOTOR + n));
		radMotor[n].setValueLabel(RAD_MOTOR_INIT,"N/A");
		radMotor[n].setModuleNo(RAD_MOTOR + n);
		radMotor[n].setCurrentValue(RAD_MOTOR_INIT);
//		Icon[] moduleIcon = radMotor[n].getModuleIcon();
//		radMotor[n].getModuleImage().setIcon(moduleIcon[0]); // DEFAULT = 0
		addModule(radMotor[n]);
	}

	void makeScreen()//DUMMY
	{
		moduleScreen = getContentPane();
		Color bgColor = new Color(208,228,208);
		moduleScreen.setBackground(bgColor);
		
		moduleScreen.setLayout(new GridLayout(7,10));
		moduleScreen.add(new JLabel("*MD-LAYER"+DUMMY));//Head
		moduleScreen.add(new JLabel("T1-Label"));//Head
		moduleScreen.add(new JLabel("T1-State"));//Head
		moduleScreen.add(new JLabel("T1-Value"));//Head
		moduleScreen.add(new JLabel("T2-Label"));//Head
		moduleScreen.add(new JLabel("T2-State"));//Head
		moduleScreen.add(new JLabel("T2-Value"));//Head
		moduleScreen.add(new JLabel("T3-Label"));//Head
		moduleScreen.add(new JLabel("T3-State"));//Head
		moduleScreen.add(new JLabel("T3-Value"));//Head

		
		moduleScreen.add(new JLabel("*SW-LEVEL"+DUMMY));//LEVEL SENSOR PREFIX -1
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(levelSensor[j].getModuleLabel());	//Level SensorP
			moduleScreen.add(levelSensor[j].getSlider());		//Level SensorP
			moduleScreen.add(levelSensor[j].getValueLabel());	//Level SensorP
		}

		moduleScreen.add(new JLabel("*RI-STATUS"+DUMMY));	//RAD SENSOR PREFIX -2
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(radSensor[j].getModuleLabel());	//Rad SensorP
			moduleScreen.add(radSensor[j].getSlider());			//Rad SensorP
			moduleScreen.add(radSensor[j].getValueLabel());		//Rad SensorP
		}

		moduleScreen.add(new JLabel("*INL-VALVE"+DUMMY));//INLET VALVE PREFIX -3
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(inletValve[j].getModuleLabel());	//INLET VALVE
			moduleScreen.add(inletValve[j].getModuleImage());	//INLET VALVE
			moduleScreen.add(inletValve[j].getValueLabel());	//INLET VALVE
		}

		moduleScreen.add(new JLabel("*RD-MOTOR"+DUMMY));//CHECK VALVE PREFIX -4
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(radMotor[j].getModuleLabel());	//CHECK VALVE
			moduleScreen.add(radMotor[j].getModuleImage());	//CHECK VALVE
			moduleScreen.add(radMotor[j].getValueLabel());	//CHECK VALVE
		}

		moduleScreen.add(new JLabel("*DR-VALVE"+DUMMY));//DRAIN VALVE PREFIX -5
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(drainValve[j].getModuleLabel());	//DRAIN VALVE
			moduleScreen.add(drainValve[j].getModuleImage());	//DRAIN VALVE
			moduleScreen.add(drainValve[j].getValueLabel());	//DRAIN VALVE
		}

		moduleScreen.add(new JLabel("*MT-PUMP"+DUMMY));//MOTOR PREFIX -6
		for (int j = 0; j < NUM_MODULE; j++)
		{
			moduleScreen.add(motor[j].getModuleLabel());		//MOTOR
			moduleScreen.add(motor[j].getModuleImage());		//MOTOR
			moduleScreen.add(motor[j].getValueLabel());			//MOTOR
		}
	}
	
	public void connect()
	{
		try
		{
			toServer = new Socket(serverURL, PORT);
			is = toServer.getInputStream();
			os = toServer.getOutputStream();
			dis = new DataInputStream(is);
			dos = new DataOutputStream(os);
			
			sendDatum(1111,1111);// INITIAL MODULE SENDER
			
			ModuleThread moduleThread = new ModuleThread(this,systemID, dis, dos, this, MODULE_PAUSE_TIME);
			Thread mT = new Thread(moduleThread);
			mT.start();
			
			ModuleStateThread moduleStateThread = new ModuleStateThread(this, MODULE_PAUSE_TIME);
			Thread msT = new Thread(moduleStateThread);
			msT.start();
			
			SupervisorThread supervisorThread = new SupervisorThread(this);
			Thread sT = new Thread(supervisorThread);
			sT.start();
			
			DataThread dataThread = new DataThread(this);
			Thread dT = new Thread(dataThread);
			dT.start();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			p.r(this,"Connection failed...");
		}
	}
	
	
	public Vector getModuleV()
	{
		return moduleV;
	}
	
	public void addModule(ModuleFace module)
	{
		moduleV.add(module);
	}
	
	public void removeModule(ModuleFace module)
	{
		moduleV.remove(module);
	}
	
	public void notifies( int moduleNo, int protocol)// <- thread
	{
		p.r(this,"notifies - moduleno",moduleNo);
		p.r(this,"notifies - protocol",protocol);
		if(moduleNo == STATER)
		{
			packet = systemID + int2String(STATER + DIGIT);
			packet += int2String(READ_MODULE_VALUE + DIGIT);
			iter = moduleV.iterator();
			for (int row = 0; row < ROW ; row ++)
			{
				for (int col = 0; col < COL;  col ++)
				{
					packet = packet + (int2String(DIGIT + (row)*100+(col))+int2String(DIGIT + moduleStateA[row][col][0]));
				}
	
			}
			try
			{
				p.r(this, "packet", packet);
				dos.writeBytes(packet);
			}
			catch(Exception e)
			{
				e.printStackTrace();
				p.r(this,"sending packet error from PseudoModule");
			}
		}
		else// -> moduleStateThread
		{
			moduleStateA[(moduleNo-moduleNo%10)/100][moduleNo%10][0] = protocol;
			moduleStateA[(moduleNo-moduleNo%10)/100][moduleNo%10][1] = 1;
		}
	}
	
	public void sendDatum(int moduleNo, int val) // initial message
	{
		try
		{
			data = (systemID + int2String(moduleNo+DIGIT) + int2String(val+DIGIT)); //.getBytes(CHAR_SET);
			p.r(this,"initial moduleNo",moduleNo);
			p.r(this,"initial module value",val);
			for (int loop =0; loop < 18; loop ++)
			{
				data += FILLER;
			}
			dos.writeBytes(data);
//			dos.write(data,0,SIZE);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	String int2String(int val)
	{
		return String.valueOf(val);
	}
	
	public int[][][] getModuleStateA()
	{
		return moduleStateA;
	}

	public void setModuleState(int[][] sensorData)
	{
		for (int col = 0 ; col < 3; col++)
		{
			levelValue = sensorData[0][col]* 100/LEVEL_MAX ;
			levelSensor[col].setCurrentValue((int)levelValue);
			p.r(this, "column" , col);
			p.r(this, "levelSensor :" , (int)levelValue);
			p.r(this, "radSensor :" , (int)radValue);
		}
		{// rad sensor 0,1,3 (2) ϱ Ͽ 迭 
			radValue = (RAD_MAX-sensorData[1][0]) ;
//			radValue = (RAD_MAX-sensorData[1][col])* 100/RAD_MAX ;
			radValue = ( radValue > 0 ? radValue: 0 );
			radSensor[0].setCurrentValue((int)radValue);

			radValue = (RAD_MAX-sensorData[1][1]) ;
//			radValue = (RAD_MAX-sensorData[1][col])* 100/RAD_MAX ;
			radValue = ( radValue > 0 ? radValue: 0 );
			radSensor[1].setCurrentValue((int)radValue);

			radValue = (RAD_MAX-sensorData[1][3]) ;
//			radValue = (RAD_MAX-sensorData[1][col])* 100/RAD_MAX ;
			radValue = ( radValue > 0 ? radValue: 0 );
			radSensor[2].setCurrentValue((int)radValue);
		}
	}
	
	public void sendModuleValue(int NO)
	{
		
	}

	public void actionPerformed(ActionEvent aE)
	{
		String command = aE.getActionCommand();
		moduleP = (ModuleP)aE.getSource();
	}

	public static void main(String args[])
	{
		new PseudoModule();
	}
}

