// File : ModuleP.java
// Gen Date : 2005.11.09
// Rev : B
// Package : module
// Writer :   

package moduleMonitor.module;

import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;


abstract class SensorP extends ModuleP
{
	SensorSliderP sensorSlider;
	int MIN;
	int MAX;
	int INITIAL;

	public SensorP(ModuleControlFace pseudoModule)
	{
		super(pseudoModule);
	}
	
	void makeSlider(int direction, int min, int max, int initial)
	{
		InitProperty initProperty = InitProperty.getInstance();
		int MAJOR_TICK = Integer.parseInt(initProperty.getValue("MAJOR_TICK"));
		int MINOR_TICK = Integer.parseInt(initProperty.getValue("MINOR_TICK"));

		LEVEL_READ = Integer.parseInt(initProperty.getValue("LEVEL_READ"));
		LEVEL_RESET = Integer.parseInt(initProperty.getValue("LEVEL_RESET"));
		RAD_READ = Integer.parseInt(initProperty.getValue("RAD_READ"));
		RAD_RESET = Integer.parseInt(initProperty.getValue("RAD_RESET"));
		
		sensorSlider = new SensorSliderP(direction, min, max, initial);
		sensorSlider.setMajorTickSpacing(MAJOR_TICK);
		sensorSlider.setMinorTickSpacing(MINOR_TICK);
		sensorSlider.setPaintTicks(true);
		sensorSlider.addChangeListener(new SensorListener(this));
	}
	
	SensorSliderP getSlider()
	{
		return sensorSlider;
	}

//	abstract public void notify( int moduleNo, int protocol);
	
	public void reset()
	{
		setCurrentValue(NORMAL_VALUE);
		setState(NORMAL_STATE);
	}
	
	public int getState()
	{
		return state;
	}
	
	public void setState(int value)
	{
		this.state = value;
		getSlider().setValue(state);
	}
	
	public int getCurrentValue()
	{
		return currentValue;
	}
	
	public void setCurrentValue(int value)
	{
//		p.r(this,moduleName,value);
		this.currentValue = value;
		setState(currentValue);
		valueLabel.setText(String.valueOf(currentValue));
	}
	
	public void operationStart()
	{
		p.r(this, "No operation");
	}
	
	public void operationStop()
	{
		p.r(this, "No operation");
	}
	
	
}
