// File : ModuleThread.java
// Gen Date : 2005.12.8
// Rev : C
// Package : module
// Writer :   

package moduleMonitor.module;

import java.util.Enumeration;
import java.util.Vector;

import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

class SupervisorThread implements Runnable
{
	ModuleControlFace pseudoModule;
	ModuleListener moduleP;
	int moduleNo;
	int NUM_MODULE;
	int WATER_BOTTOM_LIMIT;
	int WATER_UPPER_LIMIT;
	int RAD_SAFETY_LIMIT;
	int SUPERVISOR_INTERVAL_TIME;
	int RAD_CHECK_TIME;
	boolean LOOP = true;
	Enumeration enumer;
	Vector moduleV;
	ModuleFace[][] moduleA;
	ModuleFace module;
	int[][][] moduleStateA;
	int RAD = 0;
	int LEVEL = 1;
	int VALUE = 0;
	int LEVEL_SENSOR;
	int RAD_SENSOR;
	int INLET_VALVE;
	int CHECK_VALVE;
	int RAD_MOTOR;
	int DRAIN_VALVE;
	int OPER_SW;
	int TRUE = 1;
	int FALSE = 0;
	int ROW;
	int COL;
	int CLOSE = 0;
	int OPEN = 1;
	
	public SupervisorThread(ModuleControlFace pseudoModule)
	{
		this.pseudoModule = pseudoModule;
		InitProperty initProperty = InitProperty.getInstance();
		NUM_MODULE = Integer.parseInt(initProperty.getValue("NUM_MODULE"));
		LEVEL_SENSOR = Integer.parseInt(initProperty.getValue("LEVEL_SENSOR"))/100;
		RAD_SENSOR = Integer.parseInt(initProperty.getValue("RAD_SENSOR"))/100;
		INLET_VALVE = Integer.parseInt(initProperty.getValue("INLET_VALVE"))/100;
		CHECK_VALVE = Integer.parseInt(initProperty.getValue("CHECK_VALVE"))/100;
		RAD_MOTOR = Integer.parseInt(initProperty.getValue("RAD_MOTOR"))/100;
		DRAIN_VALVE = Integer.parseInt(initProperty.getValue("DRAIN_VALVE"))/100;
		OPER_SW = Integer.parseInt(initProperty.getValue("OPER_SW"))/100;
		WATER_BOTTOM_LIMIT = Integer.parseInt(initProperty.getValue("WATER_BOTTOM_LIMIT"));
		WATER_UPPER_LIMIT = Integer.parseInt(initProperty.getValue("WATER_UPPER_LIMIT"));
		RAD_SAFETY_LIMIT = Integer.parseInt(initProperty.getValue("RAD_SAFETY_LIMIT"));
		SUPERVISOR_INTERVAL_TIME = Integer.parseInt(initProperty.getValue("SUPERVISOR_INTERVAL_TIME"));
		RAD_CHECK_TIME = Integer.parseInt(initProperty.getValue("RAD_CHECK_TIME"));
		ROW = Integer.parseInt(initProperty.getValue("ROW"));
		COL = Integer.parseInt(initProperty.getValue("COL"));
		moduleStateA = pseudoModule.getModuleStateA();
		moduleV = pseudoModule.getModuleV();
		moduleA = new ModuleFace[ROW][COL];
		makeModuleArray();
	}
	
	public void makeModuleArray()
	{
		int moduleNo;
		int row;
		int col;
		enumer = moduleV.elements();// 
		p.r(this, "LEVEL_SENSOR", LEVEL_SENSOR);
		p.r(this, "RAD_SENSOR", RAD_SENSOR);
		p.r(this, "INLET_VALVE", INLET_VALVE);
		p.r(this, "RAD_MOTOR", RAD_MOTOR);
		p.r(this, "DRAIN_VALVE", DRAIN_VALVE);
		p.r(this, "OPER_SW", OPER_SW);
		
		while(enumer.hasMoreElements())
		{
			module = (ModuleFace)enumer.nextElement();
			moduleNo = module.getModuleNo();
			row = (moduleNo)/100;
			col = moduleNo % 10;
			p.r(this, "moduleNo-row", moduleNo, row);
			p.r(this, "moduleNo-col", moduleNo, col);
			moduleA[row][col] = module;
			p.r("moduleA","row",row);
			p.r("moduleA","col",col);
			{
				System.out.print(this.toString());
				System.out.print("#moduleA-No[");
				System.out.print("#" + String.valueOf(row));
				System.out.print("#]");
				System.out.print("#[");
				System.out.print("#" + String.valueOf(col));
				System.out.print("#] : ");
				System.out.println("#" + String.valueOf(moduleA[row][col].getModuleNo()));
			}
		}
	}

	void testModuleA()
	{
		for (int row = 0; row < ROW; row++)
		{
			for (int col = 0; col < COL ; col++)
			{
				System.out.print(this.toString());
				System.out.print("moduleA[");
				System.out.print(row);
				System.out.print("]");
				System.out.print("[");
				System.out.print(col);
				System.out.print("] : ");
				System.out.println(moduleA[row][col]);
			}
		}
	}
	
	public void run()
	{
		p.r(this,"run()", "SupervisorThread start");
		int col;
		int inlet_close;
		int check_flag;
		int drain_open;
		int drain_close;
		int NA = -1;
		int check_start;
		int tank = 0;
		int reservior = -1;
		int lowestLevel = 100;
		int lowestTank = -1;
		while(LOOP)
		{

			inlet_close = NA;
			check_flag = NA;
			drain_open = NA;
			drain_close = NA;
			lowestLevel = 100;
			lowestTank = -1;

			for(col = 0; col < NUM_MODULE; col++ )// inlet_Close
			{
				if (moduleStateA[LEVEL_SENSOR][col][VALUE]> WATER_UPPER_LIMIT && moduleStateA[INLET_VALVE][col][VALUE] == OPEN)
				{
					moduleA[INLET_VALVE][col].setCurrentValue(CLOSE);
					tank --;
					inlet_close = col;
				}
			}


			for(col = 0; col < NUM_MODULE; col++ )// drain_Open
			{
				if(moduleStateA[LEVEL_SENSOR][col][VALUE] > WATER_UPPER_LIMIT && moduleStateA[INLET_VALVE][col][VALUE] == CLOSE && moduleStateA[DRAIN_VALVE][col][VALUE] == CLOSE )
				{
					p.r(this,"drainCheck", col);
					if(checkRadLevel(col))
					{
						moduleA[DRAIN_VALVE][col].setCurrentValue(OPEN);
						drain_open = col;
					}
				}
			}
			
			for(col = 0; col < NUM_MODULE; col++ )// inlet_Open
			{
				if(tank <=0 && moduleStateA[LEVEL_SENSOR][col][VALUE] < WATER_BOTTOM_LIMIT && moduleStateA[INLET_VALVE][col][VALUE] == CLOSE && moduleStateA[DRAIN_VALVE][col][VALUE] == OPEN )
				{
					{
						moduleA[DRAIN_VALVE][col].setCurrentValue(CLOSE);
						moduleA[INLET_VALVE][col].setCurrentValue(OPEN);
						tank ++;
					}
				}
			}
			
			for (col = 0; col < NUM_MODULE; col++ ) // ʱ        
			{
				if(tank  <= 0 && lowestLevel > moduleA[LEVEL_SENSOR][col].getCurrentValue())
				{
					lowestTank = col;
					lowestLevel = moduleA[LEVEL_SENSOR][col].getCurrentValue();
				}
			}
			if (tank  <= 0 )
			{
				moduleA[DRAIN_VALVE][lowestTank].setCurrentValue(CLOSE);
				moduleA[INLET_VALVE][lowestTank].setCurrentValue(OPEN);
				tank ++;
			}
		
			try
			{
				Thread.currentThread().sleep(SUPERVISOR_INTERVAL_TIME);
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
	}

	boolean checkRadLevel(int col)
	{
		moduleA[OPER_SW][col].setCurrentValue(OPEN);
		try
		{
			Thread.currentThread().sleep(RAD_CHECK_TIME);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}		
		moduleA[RAD_MOTOR][col].setCurrentValue(OPEN);
		moduleA[OPER_SW][col].setCurrentValue(CLOSE);
		try
		{
			Thread.currentThread().sleep(RAD_CHECK_TIME);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}		
		moduleA[RAD_MOTOR][col].setCurrentValue(CLOSE);
		if( moduleStateA[RAD_SENSOR][col][VALUE] < RAD_SAFETY_LIMIT)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}
