// FILE: ModuleMonitor.java
// 2005.12.15
// Rev : B
// package moduleMonitor.monitor;
// writer : ѽ¹


package moduleMonitor.monitor;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;

import moduleMonitor.screen.Screen;
import moduleMonitor.screen.ScreenListener;
import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

class ModuleMonitor extends Vector implements ModuleMonitorFace
{
	int PORT;	
	int RAD_VALUE;
	int TOP_LEVEL;
	int BOTTOM_LEVEL;
	int RECEIVE_PAUSE_TIME;
	int SEND_PAUSE_TIME;
	boolean flag = false;
	boolean LOOP = true;
	
	boolean OPEN = true;
	boolean CLOSE = false;
	boolean initial = true;
	
	int radValue[] = new int[3];
	int inletValveValue[] = new int[3];
	int outletValveValue[] = new int[3];
	int levelValue[] = new int[3];
	String systemID = "KOREKKDPHINUSWCL";
	static int TANK_NO = 0;
	
	int[][][] moduleStateA = {{{50,0},{50,0},{50,0}},{{50,0},{50,0},{50,0}},{{0,0},{0,0},{0,0}},{{0,0},{0,0},{0,0}},{{0,0},{0,0},{0,0}},{{0,0},{0,0},{0,0}}};
		
	String title;
	Socket socket2Client;
	TriggerThread triggerThread;
	DemonThread demonThread;
	ScreenListener screen;
	InitProperty initProperty;
	
	
	public ModuleMonitor()
	{
		super();
	}
	
	void init()
	{
		initProperty = InitProperty.getInstance();
		PORT = Integer.parseInt(initProperty.getValue("PORT"));
		RAD_VALUE = Integer.parseInt(initProperty.getValue("RAD_MIN"));
		BOTTOM_LEVEL = Integer.parseInt(initProperty.getValue("LEVEL_MIN"));
		TOP_LEVEL = Integer.parseInt(initProperty.getValue("LEVEL_MAX"));
		SEND_PAUSE_TIME = Integer.parseInt(initProperty.getValue("SEND_PAUSE_TIME"));
		RECEIVE_PAUSE_TIME = Integer.parseInt(initProperty.getValue("RECEIVE_PAUSE_TIME"));
		
		ServerSocket masterSocket =(ServerSocket)null; 
		try
		{
			masterSocket = new ServerSocket(PORT);
		}
		
		catch(Exception e)
		{
			System.out.println("\n\n\n Server Error : PORT is in use ...\n\n");
			System.exit(-1);
		}
		System.out.println("\n\n\n  OK !  Server is running ...\n\n");
		serviceStart(masterSocket);
	}
	
	void serviceStart(ServerSocket serverMasterSocket)
	{
		p.r(this,"serviceStart",3);
		Socket socket2Client = (Socket)null;
		p.r(this,"serviceStart",4);
		while(LOOP)
		{
			p.r(this,"serviceStart",5);
			p.r(this,"serviceStart","looping");
			try
			{
				p.r(this,"serviceStart",6);
				socket2Client = serverMasterSocket.accept();//
				LOOP = false;
				p.r(this,"serviceStart",7);
				String clientAddress = socket2Client.getInetAddress().getHostAddress();
				p.r(this,"serviceStart",8);
				p.r(this,"serviceStart",clientAddress);
//				InputStreamReader isr = new InputStreamReader(socket2Client.getInputStream());
				p.r(this,"serviceStart",9);
				DataInputStream dis = new DataInputStream(socket2Client.getInputStream());
//				OutputStreamWriter osw = new OutputStreamWriter(socket2Client.getOutputStream());
				p.r(this,"serviceStart",10);
				DataOutputStream dos = new DataOutputStream(socket2Client.getOutputStream());

				p.r(this,"serviceStart",11);
				Screen screen = new Screen(this,dos);//
				p.r(this,"serviceStart",12);
				demonThread = new DemonThread(this, systemID, screen, dis, RECEIVE_PAUSE_TIME);
				p.r(this,"serviceStart",13);
				triggerThread = new TriggerThread(systemID, screen, dos, SEND_PAUSE_TIME);
				p.r(this,"serviceStart",14);
				long curTime = System.currentTimeMillis();
				String threadName = String.valueOf(curTime);
				Thread moudleDemon = new Thread(demonThread);
				Thread moduleTrigger = new Thread(triggerThread);
				p.r(this,"serviceStart",20);
//				moudleObserver.setName(threadName);
//				addElement(new MonitorThreadElement(threadName,moduleObserber));
				moudleDemon.start();
				moduleTrigger.start();
				p.r(this,"serviceStart",30);
			}
			catch(Exception e)
			{
				try
				{
					socket2Client.close();
					System.out.println("\n\n\n Client Error : thread  Ͽϴ. \n\n");
				}
				catch(IOException ioE)
				{
					System.out.println("\n\n\n Client Error : Ʈ  ֽϴ. \n\n");
				}
			}
		}
	}
	
	
//	public void update(int moduleNo, int value)
//	{
//		p.r(this,"update " , moduleNo);
//		screen.notifies(moduleNo, value);
//	}
	

	
	public void destroyThread(Thread deadThread)
	{
		String threadName = deadThread.getName();
		
		for(int i = 0 ; i < size() ; i++)
		{
			MonitorThreadElement monitorThreadElement = (MonitorThreadElement)elementAt(i);
			if(monitorThreadElement.getName().equals(threadName))
			{
				removeElementAt(i);
			}
		}
	}


	public void setInletValveValue(int NO,int value)
	{
		inletValveValue[NO] = value;
		p.r(this,"setInletValveValue()",value);
	}

	public void setOutletValveValue(int NO,int value)
	{
		outletValveValue[NO] = value;
		p.r(this,"setOutletValveValue()",value);
	}
	
	public void setRadValue(int NO,int value)
	{
		radValue[NO] = value;
		if( radValue[NO] < RAD_VALUE && levelValue[NO] > TOP_LEVEL && inletValveValue[NO] == 1)
		{
			p.r(this,"openDrainValve(ooo): radValue - ",radValue[NO]);
			triggerThread.openDrainValve(NO);
		}
		else if( levelValue[NO] < TOP_LEVEL  && outletValveValue[NO] == 1 && TANK_NO == NO && flag == CLOSE)
		{
			p.r(this,"openInletValve(ooo): levelValue - ",levelValue[NO]);
			triggerThread.openInletValve(NO);
			flag = OPEN;
		}
	}
	
	public void setLevelValue(int NO,int value)
	{
		levelValue[NO] = value;
		if(levelValue[NO] < BOTTOM_LEVEL )
		{
			p.r(this,"closeDrainValve(xxx): radValue - ",radValue[NO]);
			triggerThread.closeDrainValve(NO);
		}
		else if(levelValue[NO] > TOP_LEVEL && inletValveValue[NO] == 0 && TANK_NO == NO)
		{
			p.r(this,"closeInletValve(xxx): radValue - ",radValue[NO]);
			
			triggerThread.closeInletValve(NO);
			flag = CLOSE;
		}
		else if(initial == true)
		{
			triggerThread.openInletValve(NO);
			initial = false;
			TANK_NO = NO;
			flag = OPEN;
		}
		else if(flag == CLOSE && 	levelValue[NO] > BOTTOM_LEVEL )
		{
			TANK_NO = TANK_NO + 1;
			TANK_NO = TANK_NO - (TANK_NO / 3) * 3;
		}
		p.r(this,"current Tank no " , TANK_NO);
		p.r(this,"current vave state " , String.valueOf(flag));
		
	}
	
	public void initialSet()
	{
		for ( int n = 0; n < 3 ; n ++)
		{
			triggerThread.closeDrainValve(n);
			triggerThread.closeInletValve(n);
		}
	}		
	
	public int[][][] getModuleStateA()
	{
		return moduleStateA;
	}
	
	public static void main(String args[])
	{
		ModuleMonitor moduleMonitor = new ModuleMonitor();
		moduleMonitor.init();
	}
} /* end class ChatServer */

class MonitorThreadElement 
{
	String moduleName;
	Thread monitorThread;
	public MonitorThreadElement(String moduleName,Thread monitorThread)
	{
		this.moduleName = moduleName;
		this.monitorThread = monitorThread;
	}
	String getName()
	{
		return moduleName;
	}
}
