// FILE: TriggerThread.java
// 2005.12.15
// Rev : A
// package monitor;
// writer : ѽ¹


package moduleMonitor.monitor;


import java.io.DataOutputStream;
import java.io.IOException;

import moduleMonitor.screen.ScreenListener;
import moduleMonitor.utility.Datum;
import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

class TriggerThread implements Runnable, TriggerThreadFace
{
	ScreenListener screen;
//	OutputStreamWriter osw;
	DataOutputStream dos;
	boolean LOOP = true;
	boolean EXIT = true;
	
	Datum datum;
	int PAUSE_TIME;
	int SIZE;
	int ROW;
	int COL;
	int DIGIT;
	int STATER;
	int MONO = 101;
//	char[] msgArray;
	byte[] msgArray;
	static int NO;
	String systemID;
	InitProperty initProperty;
	String CHAR_SET;
	String DUMMY = "01234567890123456789";
	
	public TriggerThread(String systemID,ScreenListener screen, DataOutputStream dos, int PAUSE_TIME)// throws IOException
	{
		this.systemID = systemID;
		this.screen = screen;
		this.dos = dos;
		this.PAUSE_TIME = PAUSE_TIME ;
		msgArray = new byte[SIZE];
		p.r(this,"TriggerThread Create","trigger_initiated");

		initProperty = InitProperty.getInstance();
		CHAR_SET = initProperty.getValue("CHAR_SET");
		DIGIT = Integer.parseInt(initProperty.getValue("DIGIT"));		
		STATER = Integer.parseInt(initProperty.getValue("STATER"));
		ROW = Integer.parseInt(initProperty.getValue("ROW"));
		COL = Integer.parseInt(initProperty.getValue("COL"));
		SIZE = Integer.parseInt(initProperty.getValue("SIZE"));
	}

	public void run()
	{
		int i;
		int j;
		while(LOOP)
		{
			try
			{
				p.r(this,"askModuleValue-START",1);
				askModuleValue();
				Thread.currentThread().sleep(PAUSE_TIME);
				p.r(this,"askModuleValue-END",2);
			}
			catch(Exception e)
			{
				p.r(this,"run-error -> moduleNo ");
			}
		}
	}

	public void askModuleValue()
	{
		try
		{
			String message = systemID + String.valueOf(STATER+DIGIT) + String.valueOf(Datum.READ_MODULE_VALUE+DIGIT);
//			for (int loop =0; loop < 7; loop ++)
//			{
//				message += DUMMY;
//			}
			dos.writeBytes(message);
		}
		catch(IOException ioE)
		{
			ioE.printStackTrace();
		}

	}
	
	public void sendModuleCommand(int moduleNo,int command)
	{
		try
		{
			String message = systemID + String.valueOf(moduleNo+DIGIT) + String.valueOf(command+DIGIT);
			dos.writeBytes(message);
//			msgArray = message.getBytes(CHAR_SET);
//			dos.write(msgArray,0,SIZE);
		}
		catch(IOException ioE)
		{
			ioE.printStackTrace();
		}
		
	}
	

	public void openInletValve(int NO)
	{
		sendModuleCommand(NO, Datum.INLET_OPEN);
	}
	
	public void closeInletValve(int NO)
	{
		sendModuleCommand(NO, Datum.INLET_CLOSE);
	}
	
	public void openCheckValve(int NO)
	{
		sendModuleCommand(NO, Datum.CHECK_OPEN);
	}
	
	public void closeCheckValve(int NO)
	{
		sendModuleCommand(NO, Datum.CHECK_CLOSE);
	}
	
	public void openDrainValve(int NO)
	{
		sendModuleCommand(NO, Datum.DRAIN_OPEN);
	}
	
	public void closeDrainValve(int NO)
	{
		sendModuleCommand(NO, Datum.DRAIN_CLOSE);
	}
	
	public void startOperSW(int NO)
	{
		sendModuleCommand(NO, Datum.OPER_SW_START);
	}
	
	public void stopOperSW(int NO)
	{
		sendModuleCommand(NO, Datum.OPER_SW_STOP);
	}
	public void startRadMotor(int NO)
	{
		sendModuleCommand(NO, Datum.RAD_MOTOR_START);
	}
	
	public void stopRadMotor(int NO)
	{
		sendModuleCommand(NO, Datum.RAD_MOTOR_STOP);
	}
}

