// File : ModuleThreadM.java
// Gen Date : 2005.12.8
// Rev : C
// Package : module
// Writer :   

package moduleMonitor.screen;

import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import javax.swing.JLabel;

import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

class ModuleThreadM implements Runnable
{
	InputStreamReader isr;
	OutputStreamWriter osw;
	String systemID;
	String message;
	ScreenListener screen;// delete
	JLabel msgLabel;
	int moduleNo;
	int PAUSE_TIME;
	int protocol;
	int SIZE;
	int MODULEIDX;
	int SYSTEMIDX;
	int CMDSRTIDX;
	char[] data;
	boolean LOOP = true;
	
	public ModuleThreadM(String systemID, InputStreamReader isr, OutputStreamWriter osw, ScreenListener screen, int PAUSE_TIME)
	{
		this.isr = isr;
		this.osw = osw;
		this.screen = screen;
		this.PAUSE_TIME = PAUSE_TIME;
		data = new char[SIZE];

		InitProperty initProperty = InitProperty.getInstance();
		SIZE = Integer.parseInt(initProperty.getValue("SIZE"));
		SYSTEMIDX = Integer.parseInt(initProperty.getValue("SYSTEMIDX"));
		MODULEIDX = Integer.parseInt(initProperty.getValue("MODULEIDX"));
		CMDSRTIDX = Integer.parseInt(initProperty.getValue("CMDSRTIDX"));
	}
	
	public void run()
	{
		while(LOOP)
		{
			try
			{
				isr.read(data,0,SIZE);
				message = String.valueOf(data);
				if( ! (message == null))
				{
					String moduleID = message.substring(MODULEIDX,CMDSRTIDX-1);
					moduleNo = Integer.parseInt(moduleID);
					String command = message.substring(CMDSRTIDX,SIZE-1);
					protocol = Integer.parseInt(command);
					p.r(this,"run",protocol);
					decodeProtocol(moduleNo,protocol);
				}
				else
				{
					Thread.currentThread().sleep(PAUSE_TIME);
				}
			}
			
			catch(Exception e)
			{
				p.r(this,"CLIENT LOG OUT !  BYE BYE...");
				break;
			}
		}
	}
	
	void decodeProtocol(int moduleNo, int protocol) 
	{
		p.r(this,"decodeProtocol-moduleNo", moduleNo);
		p.r(this,"decodeProtocol-protocol", protocol);
		
		screen.notifies( moduleNo, protocol);// <- thread
	}

	public void sendDatum(int moduleNo, int val)
	{
		data = (systemID + int2String(moduleNo) + int2String(val)).toCharArray();
		p.r(this,"sendDatum",data);
		try
		{
			osw.write(data,0,SIZE);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	String int2String(int val)
	{
		return String.valueOf(val);
	}
}
