// FILE: Screen.java
// 2005.12.19
// Rev : Org
// package monitor;
// writer : ѽ¹


package moduleMonitor.screen;

import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JLabel;

import moduleMonitor.monitor.ModuleMonitorFace;
import moduleMonitor.utility.InitProperty;
import moduleMonitor.utility.p;

public class Screen extends JFrame implements ScreenListener, ScreenControlFace
{
	Vector moduleV = new Vector();
	Enumeration enumer;
	ModuleFaceM moduleA[][];
	LevelSensorM levelSensor[];
	RadSensorM radSensor[];
	ValveM inletValve[];
	ValveM checkValve[];
	ValveM drainValve[];
	MotorM motor[];
	RadMotorM radMotor[];
	Iterator iter;
	InitProperty initProperty;
	Container moduleScreen;

	InputStream is;
	OutputStream os;

//	DateInputStream dis;
	DataOutputStream dos;
	BufferedReader br;
	
	Socket toServer;
	Socket fmServer;
	
	String serverURL;
	static int PORT;
	static int QUE_LENGTH;
	static int MODULE_PAUSE_TIME;
	String DUMMY = "__:-:";
	char[] data;
	String DM = ":";
	String systemID;
	
	int NUM_MODULE;
	int SIZE =24;
	int DIGIT=1000;
	
	int WIN_X;
	int WIN_Y;
	int LOC_X;
	int LOC_Y;
	int COL;
	int ROW;
	
	int RAD_INIT;
	int LEVEL_INIT;
	int INLET_VALVE_INIT;
	int CHECK_VALVE_INIT;
	int DRAIN_VALVE_INIT;
	int MOTOR_INIT;
	int RAD_MOTOR_INIT;
	int GET_COMMAND;
	int[][][] moduleStateA;
	ModuleMonitorFace moduleMonitor;
	
	public Screen(ModuleMonitorFace moduleMonitor, DataOutputStream dos)
	{
		super("MODULE MONITOR FOR MONITOR SIMULATION");
//		data = new char[SIZE];
		this.dos = dos;
		this.moduleMonitor = moduleMonitor;
		initProperty = InitProperty.getInstance();
		SIZE = Integer.parseInt(initProperty.getValue("SIZE"));
		initializeParameter();
		init();
	}
	
	void initializeParameter()
	{
		NUM_MODULE = Integer.parseInt(initProperty.getValue("NUM_MODULE"));
		PORT = Integer.parseInt(initProperty.getValue("PORT"));
		serverURL = initProperty.getValue("serverURL");
		systemID = initProperty.getValue("systemID");
		QUE_LENGTH = Integer.parseInt(initProperty.getValue("QUE_LENGTH"));
		MODULE_PAUSE_TIME = Integer.parseInt(initProperty.getValue("MODULE_PAUSE_TIME"));
		WIN_X = Integer.parseInt(initProperty.getValue("WIN_X"));
		WIN_Y = Integer.parseInt(initProperty.getValue("WIN_Y"));
		LOC_X = Integer.parseInt(initProperty.getValue("LOC_X"));
		LOC_Y = Integer.parseInt(initProperty.getValue("LOC_Y"));
		RAD_INIT = Integer.parseInt(initProperty.getValue("RAD_INIT"));
		LEVEL_INIT = Integer.parseInt(initProperty.getValue("LEVEL_INIT"));
		INLET_VALVE_INIT= Integer.parseInt(initProperty.getValue("INLET_VALVE_INIT"));
		CHECK_VALVE_INIT= Integer.parseInt(initProperty.getValue("CHECK_VALVE_INIT"));
		DRAIN_VALVE_INIT= Integer.parseInt(initProperty.getValue("DRAIN_VALVE_INIT"));
		MOTOR_INIT= Integer.parseInt(initProperty.getValue("MOTOR_INIT"));
		RAD_MOTOR_INIT= Integer.parseInt(initProperty.getValue("RAD_MOTOR_INIT"));
		COL = Integer.parseInt(initProperty.getValue("COL"));
		ROW = Integer.parseInt(initProperty.getValue("ROW"));
		GET_COMMAND = Integer.parseInt(initProperty.getValue("GET_COMMAND"));
		moduleA = new ModuleFaceM[ROW][COL];
		moduleStateA = moduleMonitor.getModuleStateA();
	}

	void init()
	{
		makeInitSensor();
		makeInitValve();
		makeInitMotor();
		makeInitRadMotor();
		
		for ( int i = 0;  i < NUM_MODULE ; i++)
		{
			makeSensor(i);
			makeValve(i);
//			makeRadMotor(i);
			makeMotor(i);
		}
		makeScreen();
		setSize(WIN_X,WIN_Y);
		setLocation(LOC_X,LOC_Y);
		setVisible(true);
		makeModuleArray();	
		updateScreen();
	}
	
	void makeInitSensor()
	{
		levelSensor = new LevelSensorM[NUM_MODULE];
		radSensor = new RadSensorM[NUM_MODULE];
	}
	
	void makeInitValve()
	{
		inletValve = new ValveM[NUM_MODULE];
//		checkValve = new ValveM[NUM_MODULE];
		drainValve = new ValveM[NUM_MODULE];
	}

	void makeInitMotor()
	{
		motor = new MotorM[NUM_MODULE];// reduce
	}

	void makeInitRadMotor()
	{
		radMotor = new RadMotorM[NUM_MODULE];// reduce
	}

	void makeSensor(int n)
	{
		levelSensor[n] = new LevelSensorM(this);
		int LEVEL_SENSOR = Integer.parseInt(initProperty.getValue("LEVEL_SENSOR"));
		levelSensor[n].setModuleName("LS" + String.valueOf(LEVEL_SENSOR + n));
		levelSensor[n].setModuleLabel("LS" + String.valueOf(LEVEL_SENSOR + n));
		levelSensor[n].setValueLabel(LEVEL_INIT,"%");
		levelSensor[n].setModuleNo(LEVEL_SENSOR + n);
		levelSensor[n].setCurrentValue(LEVEL_INIT-17);
		
		addModule(levelSensor[n]);

		radSensor[n] = new RadSensorM(this);
		int RAD_SENSOR = Integer.parseInt(initProperty.getValue("RAD_SENSOR"));
		radSensor[n].setModuleName("RS" + String.valueOf(RAD_SENSOR+n));
		radSensor[n].setModuleLabel("RS" + String.valueOf(RAD_SENSOR+n));
		radSensor[n].setValueLabel(RAD_INIT,"X");
		radSensor[n].setModuleNo(RAD_SENSOR + n);
		radSensor[n].setCurrentValue(RAD_INIT-17);
		addModule(radSensor[n]);
	}
	
	void makeValve(int n)
	{
		inletValve[n] = new ValveM(this);
		int INLET_VALVE = Integer.parseInt(initProperty.getValue("INLET_VALVE"));
		inletValve[n].setModuleName("IV" + String.valueOf(INLET_VALVE + n));
		inletValve[n].setModuleLabel("IV" + String.valueOf(INLET_VALVE + n));
		inletValve[n].setValueLabel(INLET_VALVE_INIT,"N/A");
		inletValve[n].setModuleNo(INLET_VALVE + n);
		Icon[] inletModuleIcon = inletValve[n].getModuleIcon();
		inletValve[n].getModuleImage().setIcon(inletModuleIcon[0]);
		addModule(inletValve[n]);

//		checkValve[n] = new ValveM(this);
//		int CHECK_VALVE = Integer.parseInt(initProperty.getValue("CHECK_VALVE"));
//		checkValve[n].setModuleName("CV" + String.valueOf(CHECK_VALVE + n));
//		checkValve[n].setModuleLabel("CV" + String.valueOf(CHECK_VALVE + n));
//		checkValve[n].setValueLabel(CHECK_VALVE_INIT,"N/A");
//		checkValve[n].setModuleNo(CHECK_VALVE + n);
//		Icon[] checkModuleIcon = checkValve[n].getModuleIcon();
//		checkValve[n].getModuleImage().setIcon(checkModuleIcon[1]); // DEFAULT = 0
//		addModule(checkValve[n]);

		makeRadMotor(n);

		drainValve[n] = new ValveM(this);
		int DRAIN_VALVE = Integer.parseInt(initProperty.getValue("DRAIN_VALVE"));
		drainValve[n].setModuleName("DV" + String.valueOf(DRAIN_VALVE + n));
		drainValve[n].setModuleLabel("DV" + String.valueOf(DRAIN_VALVE + n));
		drainValve[n].setValueLabel(DRAIN_VALVE_INIT,"N/A");
		drainValve[n].setModuleNo(DRAIN_VALVE + n);
		Icon[] drainModuleIcon = drainValve[n].getModuleIcon();
		drainValve[n].getModuleImage().setIcon(drainModuleIcon[0]);
		addModule(drainValve[n]);
	}
	
	void makeMotor(int n)
	{
		motor[n] = new MotorM(this);
		int MOTOR =  Integer.parseInt(initProperty.getValue("MOTOR"));
		motor[n].setModuleName("MT"+String.valueOf(MOTOR + n));
		motor[n].setModuleLabel("MT"+String.valueOf(MOTOR + n));
		motor[n].setValueLabel(MOTOR_INIT,"N/A");
		motor[n].setModuleNo(MOTOR + n);
		Icon[] moduleIcon = motor[n].getModuleIcon();
		motor[n].getModuleImage().setIcon(moduleIcon[1]); // DEFAULT = 0
		addModule(motor[n]);
	}

	void makeRadMotor(int n)
	{
		radMotor[n] = new RadMotorM(this);
		int RAD_MOTOR =  Integer.parseInt(initProperty.getValue("RAD_MOTOR"));
		radMotor[n].setModuleName("RM"+String.valueOf(RAD_MOTOR + n));
		radMotor[n].setModuleLabel("RM"+String.valueOf(RAD_MOTOR + n));
		radMotor[n].setValueLabel(RAD_MOTOR_INIT,"N/A");
		radMotor[n].setModuleNo(RAD_MOTOR + n);
		Icon[] moduleIcon = radMotor[n].getModuleIcon();
		radMotor[n].getModuleImage().setIcon(moduleIcon[1]); // DEFAULT = 0
		addModule(radMotor[n]);
	}
		
	void makeScreen()//DUMMY
	{
		moduleScreen = getContentPane();
		Color bgColor = new Color(208,228,208);
		moduleScreen.setBackground(bgColor);
		moduleScreen.setLayout(new GridLayout(7,10));
		moduleScreen.add(new JLabel("*MD-LAYER"+DUMMY));//Head
		moduleScreen.add(new JLabel("T1-Label"));//Head
		moduleScreen.add(new JLabel("T1-State"));//Head
		moduleScreen.add(new JLabel("T1-Value"));//Head
		moduleScreen.add(new JLabel("T2-Label"));//Head
		moduleScreen.add(new JLabel("T2-State"));//Head
		moduleScreen.add(new JLabel("T2-Value"));//Head
		moduleScreen.add(new JLabel("T3-Label"));//Head
		moduleScreen.add(new JLabel("T3-State"));//Head
		moduleScreen.add(new JLabel("T3-Value"));//Head

		moduleScreen.add(new JLabel("*SW-LEVEL"+DUMMY));//LEVEL SENSOR PREFIX -1
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(levelSensor[j].getModuleLabel());	//Level Sensor
			moduleScreen.add(levelSensor[j].getSlider());		//Level Sensor
			moduleScreen.add(levelSensor[j].getValueLabel());	//Level Sensor
		}

		moduleScreen.add(new JLabel("*RI-STATUS"+DUMMY));	//RAD SENSOR PREFIX -2
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(radSensor[j].getModuleLabel());	//Rad Sensor
			moduleScreen.add(radSensor[j].getSlider());			//Rad Sensor
			moduleScreen.add(radSensor[j].getValueLabel());		//Rad Sensor
		}

		moduleScreen.add(new JLabel("*INL-VALVE"+DUMMY));//INLET VALVE PREFIX -3
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(inletValve[j].getModuleLabel());	//INLET VALVE
			moduleScreen.add(inletValve[j].getModuleImage());	//INLET VALVE
			moduleScreen.add(inletValve[j].getValueLabel());	//INLET VALVE
		}

		moduleScreen.add(new JLabel("*RD_MOTOR"+DUMMY));//CHECK VALVE PREFIX -4
//		for ( int j = 0 ; j < NUM_MODULE ; j++)
//		{
//			moduleScreen.add(checkValve[j].getModuleLabel());	//CHECK VALVE
//			moduleScreen.add(checkValve[j].getModuleImage());	//CHECK VALVE
//			moduleScreen.add(checkValve[j].getValueLabel());	//CHECK VALVE
//		}
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(radMotor[j].getModuleLabel());	//CHECK VALVE
			moduleScreen.add(radMotor[j].getModuleImage());	//CHECK VALVE
			moduleScreen.add(radMotor[j].getValueLabel());	//CHECK VALVE
		}

		moduleScreen.add(new JLabel("*DR-VALVE"+DUMMY));//DRAIN VALVE PREFIX -5
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(drainValve[j].getModuleLabel());	//DRAIN VALVE
			moduleScreen.add(drainValve[j].getModuleImage());	//DRAIN VALVE
			moduleScreen.add(drainValve[j].getValueLabel());	//DRAIN VALVE
		}

		moduleScreen.add(new JLabel("*MT-PUMP"+DUMMY));//MOTOR PREFIX -6
		for ( int j = 0 ; j < NUM_MODULE ; j++)
		{
			moduleScreen.add(motor[j].getModuleLabel());		//MOTOR
			moduleScreen.add(motor[j].getModuleImage());		//MOTOR
			moduleScreen.add(motor[j].getValueLabel());			//MOTOR
		}
//			moduleScreen.add(radMotor[0].getModuleLabel());		//MOTOR
//			moduleScreen.add(radMotor[0].getModuleImage());		//MOTOR
//			moduleScreen.add(radMotor[0].getValueLabel());		//MOTOR
//
//			moduleScreen.add(motor[1].getModuleLabel());		//MOTOR
//			moduleScreen.add(motor[1].getModuleImage());		//MOTOR
//			moduleScreen.add(motor[1].getValueLabel());			//MOTOR
	}
	
	public void makeModuleArray()
	{
		enumer = moduleV.elements();
		for ( int col = 0; col < COL ; 	col++)
		{
			for ( int row = 0; row < ROW ; row++)
			{
				p.r(this,"ROW ", row);
				p.r(this,"COL ", col);
				moduleA[row][col] = (ModuleFaceM)enumer.nextElement() ;
				p.r(this,"moduleNo", moduleA[row][col].getModuleNo());
//				for ( int z = 0; z < 10000000 ; 	z++);
				
			}
		}
	}
	

	public void updateScreen()
	{
		try
		{
			p.r(this,"updateScreen 0");
//			sendDatum(0,0);// INITIAL MODULE SENDER
			ScreenThread screenThread = new ScreenThread( systemID,moduleA, moduleStateA, this);
			p.r(this,"updateScreen 1");
			Thread sT = new Thread(screenThread);
			p.r(this,"updateScreen 2");
			sT.start();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			p.r(this,"Connection failed...");
		}
	}
	
	public Vector getModuleV()
	{
		return moduleV;
	}
	
	public void addModule(ModuleObserverM module)
	{
		moduleV.add(module);
	}
	
	public void removeModule(ModuleObserverM module)
	{
		moduleV.remove(module);
	}
	
	public void notifies(int moduleNo, int value)// <- DemonThread
	{
		iter = moduleV.iterator();
		while(iter.hasNext())
		{
			((ModuleObserverM)iter.next()).notify(moduleNo, value);
		}
	}
	
	public void sendModuleCommand(int NO)
	{
		notifies(NO,GET_COMMAND);
	}
	

	public void sendDatum(int moduleNo,int command)
	{
		try
		{
			String message = systemID + String.valueOf(moduleNo+DIGIT) + String.valueOf(command+DIGIT);
			dos.writeBytes(message);
		}
		catch(IOException ioE)
		{
			ioE.printStackTrace();
		}
		
	}
	
	
	String int2String(int val)
	{
		return String.valueOf(val);
	}
	
	
	public void sendModuleValue(int NO)
	{
		
	}

	public void actionPerformed(ActionEvent aE)
	{
		String command = aE.getActionCommand();
		ModuleM module = (ModuleM)aE.getSource();
	}

}
