// File : ModuleM.java
// Gen Date : 2005.11.09
// Rev : B
// Package : module
// Writer :   

package moduleMonitor.screen;

import moduleMonitor.utility.InitProperty;


abstract class SensorM extends ModuleM
{
	SensorSliderM sensorSlider;
	int MIN;
	int MAX;
	int INITIAL;

	public SensorM(ScreenControlFace screen)
	{
		super(screen);
	}
	
	void makeSlider(int direction, int min, int max, int initial)
	{
		InitProperty initProperty = InitProperty.getInstance();
		int MAJOR_TICK = Integer.parseInt(initProperty.getValue("MAJOR_TICK"));
		int MINOR_TICK = Integer.parseInt(initProperty.getValue("MINOR_TICK"));

		LEVEL_READ = Integer.parseInt(initProperty.getValue("LEVEL_READ"));
		LEVEL_RESET = Integer.parseInt(initProperty.getValue("LEVEL_RESET"));
		RAD_READ = Integer.parseInt(initProperty.getValue("RAD_READ"));
		RAD_RESET = Integer.parseInt(initProperty.getValue("RAD_RESET"));
		
		sensorSlider = new SensorSliderM(direction, min, max, initial);
		sensorSlider.setMajorTickSpacing(MAJOR_TICK);
		sensorSlider.setMinorTickSpacing(MINOR_TICK);
		sensorSlider.setPaintTicks(true);
		sensorSlider.addChangeListener(new SensorListenerM(this));
	}
	
	SensorSliderM getSlider()
	{
		return sensorSlider;
	}
	
	public void reset()
	{
		setCurrentValue(NORMAL_VALUE);
		setState(NORMAL_STATE);
	}
	
	public void openValve()
	{
		setCurrentValue(OPEN_VALUE);
		setState(OPEN_STATE);
	}
	
	public void closeValve()
	{
		setCurrentValue(CLOSE_VALUE);
		setState(CLOSE_STATE);
	}
	public int getState()
	{
		return state;
	}
	
	public void setState(int state)
	{
		this.state = state;

	}
	
	public int getCurrentValue()
	{
		return currentValue;
	}
	
	public void setCurrentValue(int currentValue)
	{
//		p.r(this,moduleName,currentValue);
		this.currentValue = currentValue;
		valueLabel.setText(String.valueOf(currentValue));
	}
}
